package model;

/**
 * Una lista concatenata che ha i dati in ordine crescente
 * @author giovanni.ragno
 */
public interface ListaOrdinata<T extends Comparable<T>> {
  /**
   * Inserisce in lista il dato mettendolo nella posizione che garantisce l'ordinamento crescente
   * @param dato il dato da inserire
   */
  public void inserisci(T dato);
  /**
   * Restituisce la posizione del dato (a partire da 0 che indica il primo elemento)
   * @param dato il dato da cercare
   * @return la posizione trovata, se il dato manca restituisce -1
   */
  public int posto(T dato);
  /**
   * Rimmuove il dato  dalla lista, se il dato manca fa nulla
   * @param dato il dato da rimuovere
   */
  public void rimuovi(T dato);
  /**
   * Elimina ogni dato dalla lista
   */
  public void svuota();
  /**
   * @return il numero di dati presenti in lista
   */
  public int lunghezza();      
}
